{Copyright (c) <2008> <Luke J. Parker>}
{{

how to access a byte of a long in Main ram:
byte[@place[# in array]][byte in long]
byte[@luke1[0]][0]

phsa - accumulator
frqa - contents added to phsa

~~ output/high/-1

~input/low/zero

andn outa - low  - 0
or   outa - high - 1
xor  outa - toggle

or   dira, - output
andn dira, -input

false = 0
true = -1  {1111_1111 1111_1111 1111_1111 1111_1111}

repeat until x - repeat until x is true (negative logic)
Repeat while x - repeat while x is true (positive logic)

add wcnt, cnt   
add wcnt, #9     '9 + x minimum
waitcnt wcnt, #0 'this will wait 13 + x clocks total

muxc - set state according to the C state 
}}

Obj
  text  : "tv_text"
  CogCnter:  "COG_Counter"
  
Pub Start (pin)
  return (text.start(pin))
Pub Stop
  text.stop  
Pub Refresh
  repeat 3
    text.out(" ")
  'text.str(string(13))
  'text.out($01)
  'waitcnt (10_000_000 + cnt)


Pub Home
  text.out($01)

Pub Clear
  text.out($00)

Pub Str(passedstring)
  text.str(passedstring)
Pub Dec(d)
  text.dec(d)
Pub Bin(b,digits)
  text.bin(b,digits)  
Pub Hex(h,digits)
  text.hex(h,digits)
Pub Retrn
  text.out($0D)
Pub out (c)
  text.out(c)
{{       }}
Pub CogCounter
  TextXY(0,12)
  text.str(string("# of Cogs free"))
  TextXY(15,12)
  text.dec(CogCnter.free_cogs)
      
Pub TextXY(column,row) 
  text.out($0A)        
  text.out(column)    
  text.out($0B)
  text.out(row)
PUB setColor(c)
  text.out($C)
  text.out(c)
Pub Spc (i)
  repeat i
    text.out(" ")
Pub Refreshx (i)
  repeat i
    text.out(" ")
Pub Leftjust(value,spaces)
  ''Takes value and left justifies it in "spaces" amount of spaces
  text.dec(value)              ''i.e. blahblah342blah24 blah1  blah
  case value                   ''The above call would be:
    0..9 : Spc(spaces-1)       ''Lukes_Quickies_002.Leftjust(value,3)
    10..99 : Spc(spaces-2)     ''Where value is any number < 1000
    100..999 : Spc(spaces-3)   ''Also note that value is a variable
    1000..9999 : Spc(spaces-4)
    10000..99999 : Spc(spaces-5)
    100000..999999 : Spc(spaces-6)
    1000000..9999999 : Spc(spaces-7)
    10000000..99999999 : Spc(spaces-8)
    100000000..999999999 : Spc(spaces-9)
Pub Rightjust(value,spaces)
  ''Takes value and right justifies it in "spaces" amount of spaces
  case value                         ''i.e. blahblah342blah 24blah  1blah
    0..9 : Spc(spaces-1)             ''The above call would be:             
    10..99 : Spc(spaces-2)           ''Lukes_Quickies_002.Rightjust(value,3)
    100..999 : Spc(spaces-3)         ''Where value is any number < 1000     
    1000..9999 : Spc(spaces-4)       ''Also note that value is a variable                                      
    10000..99999 : Spc(spaces-5)                                        
    100000..999999 : Spc(spaces-6)                                      
    1000000..9999999 : Spc(spaces-7)                                    
    10000000..99999999 : Spc(spaces-8)
    100000000..999999999 : Spc(spaces-9)
  text.dec(value)      
Pub Tabval(value,spaces)
  text.dec(value) 
  case value
    0..9 : Spc(spaces-2)
    10..99 : Spc(spaces-3)
    100..999 : Spc(spaces-4)
    1000..9999 : Spc(spaces-5)
    10000..99999 : Spc(spaces-6)
    100000..999999 : Spc(spaces-7)
    1000000..9999999 : Spc(spaces-8)
    10000000..99999999 : Spc(spaces-9)
    100000000..999999999 : Spc(spaces-10)

Pub Tab (value)  'Used only for <9bit decimal values, a.k.a. bytes
  text.dec(value)                                       'This will place "dec" 9bit (or less, 8bit)
  if value < 10                                         'on tabs, 8 across the tv like this:                                                                                      
    text.str(string("  "))                              '125  26   63   45   2    489  256  456
  elseif (10 =< value) and (value < 100)
    text.str(string(" "))
  text.str(string("  "))

Pub Tabbin (value)  'Used only for 8 bit binary values, a.k.a. bytes  'This will place "dec" 9bit (or less, 8bit) 
  text.bin(value,8)                                                'on tabs, 8 across the tv like this:          
  text.str(string(" "))                                            '125  26   63   45   2    489  256  456
Dat
{{
''=========================================================================================
' Multiply
' Timing info : 0.000_002_35 sec  or 425531 Hz @188clocks
' on entry, x[15..0] mult. by y[15..0] (y[31..16] must be 0) 
' on exit,  y[31..0] holds the product
multiply                shl x,#16             '8          'get multiplicand into x[31..16]
                        mov t,#16             '12         'ready for 16 multiplier bits
                        shr y,#1     wc       '16         'get initial multiplier bit into c
:multloop     if_c      add y,x      wc       '20         'if c set, add multiplicand into product
                        rcr y,#1     wc       '24         'get next multiplier bit into c, shift product
                        djnz t,#:multloop     '28 - 184   'loop until done
multiply_ret            ret                   '32 - 188   'return with product in y[31..0]
''=========================================================================================
' Divide routine
' on entry, x[31..0] is divided by y[15..0] (y[16] must be 0)
' on exit, quotient is in x[15..0] and remainder is in x[31..16]
divide                  shl y,#15             '8          'get divisor into y[30..15]
                        mov t,#16             '12          'ready for 16 quotient bits
:divloop                cmpsub x,y      wc    '16          'if y =< x then subtract it, quotient bit into c
                        rcl x,#1              '          'rotate c into quotient,
                        djnz t,#:divloop                   'loop until done
divide_ret              ret                             'quotient in x[15..0], remainder in x[31..16]
''=========================================================================================                        
' Convert number to exponent
' on entry: y holds 32-bit unsigned value
' on exit:  x holds 21-bit exponent with 5 integer bits and 16 fractional bits
numexp                  mov   x, #0              'clear exponent
                        test  y, hFFFF0000    wz      'get integer portion of exponent
                        muxnz x, h00100000            'while top-justifying number
        if_z            shl   y, #16
                        test  y, hFF000000    wz
                        muxnz x, h00080000
        if_z            shl   y, #8
                        test  y, hF0000000    wz
                        muxnz x, h00040000
        if_z            shl   y, #4
                        test  y, hC0000000    wz
                        muxnz x, h00020000
        if_z            shl   y, #2
                        test  y, h80000000    wz
                        muxnz x, h00010000
        if_z            shl   y, #1

                        shr y, #30-11             'justify sub-leading bits as word
                        and y, table_mask         'isolate table offset bits
                        add y, table_log          'add log table address
                        rdword y, y             'read fractional portion of exponent
                        or x, y                 'combine fractional & integer portions
numexp_ret              ret                         '91..106 clocks
                                                    '(variance due to HUB sync on RDWORD)
''=========================================================================================

'Sub-Routine (mult, div, numexp, etc...) variables
x             long    0         'These are very dynamic variables used in many routines
y             long    0
t             long    0
'===================================
h00FFFFFF     long    $00FFFFFF          '00000000 11111111 11111111 11111111
h0000FFFF     long    $0000FFFF          '00000000 00000000 11111111 11111111 
h00000FFF     long    $00000FFF          '00000000 00000000 00001111 11111111                                          
hFFFF0000     long    $FFFF0000          '11111111 11111111 00000000 00000000
hFF000000     long    $FF000000          '11111111 00000000 00000000 00000000
hF0000000     long    $F0000000          '11110000 00000000 00000000 00000000
hC0000000     long    $C0000000          '11000000 00000000 00000000 00000000
h80000000     long    $80000000          '10000000 00000000 00000000 00000000
h00100000     long    $00100000          '00000000 00010000 00000000 00000000
h00080000     long    $00080000          '00000000 00001000 00000000 00000000
h00040000     long    $00040000          '00000000 00000100 00000000 00000000
h00020000     long    $00020000          '00000000 00000010 00000000 00000000
h00010000     long    $00010000          '00000000 00000001 00000000 00000000
table_mask    long    $0FFE                           'table offset mask
table_log     long    $C000                           'log table base
''=========================================================================================
}}
{{
Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}}